/******************************************************************/
/*                                                                */
/*   mio64e3 read_data.c - Perform  ..........                    */
/*                                                                */
/******************************************************************/

#include "tools.h"  
#define false	0
#define true	1


short main(){
   int fd,
       i,
       read_return,
       byte_count=0,
       channel_count=0,
       number_of_channels=0,
       read_number_of_bytes=1;
   char buff[read_number_of_bytes];
   short ioctl_error=0,
	 low_byte=true,
         low_and_high_byte;
   long sample_count=0;
   struct connect_bytes{
      char low;
      char high;};
   struct connect_bytes *cb=(struct connect_bytes *)&low_and_high_byte;
   time_t read_time,
          read_time_old,
          acquisition_start_time;
acquisition_start_time=time(&read_time);
read_time_old=acquisition_start_time;

  fd=open((DEVNAME), O_RDONLY);
  printf("# open: fd=%d, %s\n",fd,(DEVNAME));

  if (fd<=0) exit(0);

  printf("# ioctl: %d, Init\n",ioctl(fd,Init));
  number_of_channels=ioctl(fd,Get_Number_Of_Channels);
  printf("# ioctl: %d, Get_Number_Of_Channels\n",number_of_channels);
  printf("# ioctl: %d, Get_Number_Of_Scans\n",ioctl(fd,Get_Number_Of_Scans));
  printf("# ioctl: %d, Get_Number_Of_Sequences\n",ioctl(fd,Get_Number_Of_Sequences));

   do {
      read_return=read(fd,buff,read_number_of_bytes);  
      for (i=0;i<read_return;i++){
	 if (byte_count==0){
	    sample_count++;
	    if (read_time_old < time(&read_time)){
               printf("# time:   %6ds\n", read_time-acquisition_start_time);
	       read_time_old=read_time;}
            printf("# sample: %6d\n", sample_count);}
	 switch (low_byte){
         case true: low_byte=false;
                   (*cb).low=buff[i];
                   byte_count++;
                   break;
         case false: low_byte=true;
                   (*cb).high=buff[i];
                   printf("%6d ",low_and_high_byte);
                   byte_count++;
                   channel_count++;
                   if (channel_count==number_of_channels){
                      channel_count=0;
                      byte_count=0;
                      printf("\n");
                      fflush(stdout);}
                   break;}}
      } while(read_return>0);
   cleanup(fd);
if (read_return<0) return read_return;
else return 0;}
