#define AI_Clear                            0x0000


#define AI_All_Interrupt_A_Ack              0xFF00
#define AI_All_Error_A_Confirm              0x00E0
/* Interrupt_A_Ack_Register         16         0x02 */
/* #define  Reserved                       0x0001 */
/* #define  Reserved                       0x0002 */
/* #define  Reserved                       0x0004 */
/* #define  Reserved                       0x0008 */
/* #define  Reserved                       0x0010 */
#define  G0_Gate_Error_Confirm          0x0020
#define  G0_TC_Error_Confirm            0x0040
#define  AI_SC_TC_Error_Confirm         0x0080
#define  AI_SC_TC_Interrupt_Ack         0x0100
#define  AI_START1_Interrupt_Ack        0x0200
#define  AI_START2_Interrupt_Ack        0x0400
#define  AI_START_Interrupt_Ack         0x0800
#define  AI_STOP_Interrupt_Ack          0x1000
#define  AI_Error_Interrupt_Ack         0x2000
#define  G0_TC_Interrupt_Ack            0x4000
#define  G0_Gate_Interrupt_Ack          0x8000


#define AI_All_Interrupt_B_Ack              0xFFC0
#define AI_All_Error_B_Confirm              0x003E

/* Interrupt_B_Ack_Register         16         0x03 */
/* #define  Reserved                       0x0001 */
#define  G1_Gate_Error_Confirm          0x0002
#define  G1_TC_Error_Confirm            0x0004
#define  AO_BC_TC_Trigger_Error_Confirm 0x0008
#define  AO_BC_TC_Error_Confirm         0x0010
#define  AO_UI2_TC_Error_Confirm        0x0020
#define  AO_UI2_TC_Interrupt_Ack        0x0040
#define  AO_UC_TC_Interrupt_Ack         0x0080
#define  AO_BC_TC_Interrupt_Ack         0x0100
#define  AO_START1_Interrupt_Ack        0x0200
#define  AO_UPDATE_Interrupt_Ack        0x0400
#define  AO_START_Interrupt_Ack         0x0800
#define  AO_STOP_Interrupt_Ack          0x1000
#define  AO_Error_Interrupt_Ack         0x2000
#define  G1_TC_Interrupt_Ack            0x4000
#define  G1_Gate_Interrupt_Ack          0x8000

#define Write_Strobe_0                      0x0001
#define Write_Strobe_1                      0x0001
#define Write_Strobe_2                      0x0001
#define Write_Strobe_3                      0x0001

#define Differential                        0x1000
#define Referenced_Single_Ended             0x3000
#define Diff	Differential
#define RSE	Referenced_Single_Ended

#define LastChan         0x8000
#define Unip             0x0100
#define Bip              0x0000
#define Gain05           0x0000
#define Gain1            0x0001
#define Gain2            0x0002
#define Gain5            0x0003
#define Gain10           0x0004
#define Gain20           0x0005
#define Gain50           0x0006
#define Gain100          0x0007

#define Slow_Internal_Time_Divide_By_2      0x1000
#define Slow_Internal_Timebase              0x0800
#define Clock_To_Board_Divide_By_2          0x0200
#define Clock_To_Board                      0x0100
#define AI_Output_Divide_By_2               0x0080

#define AI_SHIFTIN_Pulse_Width              0x8000
#define AI_SOC_Polarity                     0x2000
#define AI_CONVERT_Pulse_Width              0x0400
#define AI_Overrun_Mode                     0x0080
#define AI_LOCALMUX_CLK_Pulse_Width         0x0020

/* AI_Output_Control_Register       16         0x3C */
/* #define  AI_CONVERT_Output_Select       0x0001 */
/* #define  AI_CONVERT_Output_Select       0x0002 */
/* #define  AI_SC_TC_Output_Select         0x0004 */
/* #define  AI_SC_TC_Output_Select         0x0008 */
/* #define  AI_LOCALMUX_CLK_Output_Select  0x0010 */
/* #define  AI_LOCALMUX_CLK_Output_Select  0x0020 */
/* #define  AI_EXTMUX_CLK_Output_Select    0x0040 */
/* #define  AI_EXTMUX_CLK_Output_Select    0x0080 */
/* #define  AI_SCAN_IN_PROG_Output_Select  0x0100 */
/* #define  AI_SCAN_IN_PROG_Output_Select  0x0200 */
#define  AI_START_Output_Select         0x0400
/* #define  Reserved                       0x0800 */
/* #define  Reserved                       0x1000 */
/* #define  Reserved                       0x2000 */
/* #define  Reserved                       0x4000 */
/* #define  Reserved                       0x8000 */

/* IO_Bidirection_Pin_Register      16         0x39 */
#define  BD_0_Pin_Dir                   0x0001
#define  BD_1_Pin_Dir                   0x0002
#define  BD_2_Pin_Dir                   0x0004
#define  BD_3_Pin_Dir                   0x0008
#define  BD_4_Pin_Dir                   0x0010
#define  BD_5_Pin_Dir                   0x0020
#define  BD_6_Pin_Dir                   0x0040
#define  BD_7_Pin_Dir                   0x0080
#define  BD_8_Pin_Dir                   0x0100
#define  BD_9_Pin_Dir                   0x0200
/* #define  Reserved                       0x0400 */
/* #define  Reserved                       0x0800 */
/* #define  Reserved                       0x1000 */
/* #define  Reserved                       0x2000 */
/* #define  Reserved                       0x4000 */
/* #define  Reserved                       0x8000 */

/* AI_Command_2_Register            16         0x04 */
#define AI_START1_Pulse                 0x0001
#define AI_START2_Pulse                 0x0002
#define AI_START_Pulse                  0x0004
#define AI_STOP_Pulse                   0x0008
#define AI_SC_Switch_Load_On_TC         0x0010
/* #define Reserved                        0x0020 */
/* #define Reserved                        0x0040 */
#define AI_SI_Switch_Load_On_TC         0x0080
#define AI_SI_Switch_Load_On_STOP       0x0100
#define AI_SI_Switch_Load_On_SC_TC      0x0200
#define AI_SC_Save_Trace                0x0400
#define AI_START1_Disable               0x0800
/* #define Reserved                        0x1000 */
/* #define Reserved                        0x2000 */
#define AI_End_On_End_Of_Scan           0x4000
#define AI_End_On_SC_TC                 0x8000

/* Status Register                   8         0x01 */
#define PROMOUT                         0x0001
#define DMATCA                          0x0002
#define DMATCB                          0x0004
#define DMATCC                          0x0008
/* #define Reserved                        0x0010 */
/* #define Reserved                        0x0020 */
/* #define Reserved                        0x0040 */
/* #define Reserved                        0x0080 */

/* AI_Status_1_Register             16         0x02 */
#define Pass_Thru_0_Interrupt_St        0x0001
#define AI_FIFO_Request_St              0x0002
#define G0_Gate_Interrupt_St            0x0004
#define G0_TC_St                        0x0008
#define AI_STOP_St                      0x0010
#define AI_START_St                     0x0020
#define AI_SC_TC_St                     0x0040
#define AI_START1_St                    0x0080
#define AI_START2_St                    0x0100
#define AI_SC_TC_Error_St               0x0200
#define AI_Overflow_St                  0x0400
#define AI_Overrun_St                   0x0800
#define AI_FIFO_Empty_St                0x1000
#define AI_FIFO_Half_Full_St            0x2000
#define AI_FIFO_Full_St                 0x4000
#define Interrupt_A_St                  0x8000

#define  AI_START_Select_SI_TC          0x0000       /* default for the bit field */
#define  AI_STOP_Select_SI2_TC          (unsigned short)(18<<7)
#define  AI_STOP_Select_STOP_IN_pin     (unsigned short)(19<<7)
unsigned short mirror_AI_START_STOP_Select_Register=0;
/* AI_START_STOP_Select_Register    16         0x3E */
/* #define  AI_START_Select                0x0001 */
/* #define  AI_START_Select                0x0002 */
/* #define  AI_START_Select                0x0004 */
/* #define  AI_START_Select                0x0008 */
/* #define  AI_START_Select                0x0010 */
#define  AI_START_Edge                  0x0020
#define  AI_START_Sync                  0x0040
/* #define  AI_STOP_Select                 0x0080 */
/* #define  AI_STOP_Select                 0x0100 */
/* #define  AI_STOP_Select                 0x0200 */
/* #define  AI_STOP_Select                 0x0400 */
/* #define  AI_STOP_Select                 0x0800 */
#define  AI_STOP_Edge                   0x1000
#define  AI_STOP_Sync                   0x2000
#define  AI_STOP_Polarity               0x4000
#define  AI_START_Polarity              0x8000

/* AI_Trigger_Select_Register       16         0x3F */
/* #define  AI_START1_Select               0x0001 */
/* #define  AI_START1_Select               0x0002 */
/* #define  AI_START1_Select               0x0004 */
/* #define  AI_START1_Select               0x0008 */
/* #define  AI_START1_Select               0x0010 */
#define  AI_START1_Edge                 0x0020
#define  AI_START1_Sync                 0x0040
/* #define  AI_START2_Select               0x0080 */
/* #define  AI_START2_Select               0x0100 */
/* #define  AI_START2_Select               0x0200 */
/* #define  AI_START2_Select               0x0400 */
/* #define  AI_START2_Select               0x0800 */
#define  AI_START2_Edge                 0x1000
#define  AI_START2_Sync                 0x2000
#define  AI_START2_Polarity             0x4000
#define  AI_START1_Polarity             0x8000

/* AO_Status_1_Register             16         0x03 */
#define   Pass_Thru_1_Interrupt_St      0x0001
#define   AO_FIFO_Request_St            0x0002
#define   G1_Gate_Interrupt_St          0x0004
#define   G1_TC_St                      0x0008
#define   AO_UI2_TC_St                  0x0010
#define   AO_UPDATE_St                  0x0020
#define   AO_UC_TC_St                   0x0040
#define   AO_BC_TC_St                   0x0080
#define   AO_START1_St                  0x0100
#define   AO_Overrun_St                 0x0200
#define   AO_START_St                   0x0400
#define   AO_BC_TC_Error_St             0x0800
#define   AO_FIFO_Empty_St              0x1000
#define   AO_FIFO_Half_Full_St          0x2000
#define   AO_FIFO_Full_St               0x4000
#define   Interrupt_B_St                0x8000

/* AO_Trigger_Select_Register       16         0x43 */
/* #define  AO_START1_Select               0x0001 */
/* #define  AO_START1_Select               0x0002 */
/* #define  AO_START1_Select               0x0004 */
/* #define  AO_START1_Select               0x0008 */
/* #define  AO_START1_Select               0x0010 */
#define  AO_START1_Edge                 0x0020
#define  AO_START1_Sync                 0x0040
/* #define  AO_UI2_Source_Select           0x0080 */
/* #define  AO_UI2_Source_Select           0x0100 */
/* #define  AO_UI2_Source_Select           0x0200 */
/* #define  AO_UI2_Source_Select           0x0400 */
/* #define  AO_UI2_Source_Select           0x0800 */
#define  AO_UI2_Source_Polarity         0x1000
#define  AO_START1_Polarity             0x2000
#define  AO_Delayed_START1              0x4000
#define  AO_UI2_External_Gate_Enable    0x8000

/* Strobes Register                  8         0x01 */
#define DmaTcAClr                       0x0001
#define DmaTcBClr                       0x0002
#define DmaTcCClr                       0x0004
/* #define Reserved                        0x0008 */
/* #define Reserved                        0x0010 */
/* #define Reserved                        0x0020 */
/* #define Reserved                        0x0040 */
/* #define Reserved                        0x0080 */

unsigned short mirror_AI_Mode_1_Register=0;
#define AI_SI_Source_IN_TIMEBASE2           (unsigned short)(19<<6) /* 0x04C0 */
/* AI_Mode_1_Register               16         0x0C */
#define  AI_Trigger_Once                0x0001
#define  AI_Continuous                  0x0002
#define  Reserved_One                   0x0004
#define  AI_Start_Stop                  0x0008
#define  AI_SI_Source_Polarity          0x0010
#define  AI_CONVERT_Source_Polarity     0x0020
/* #define  AI_SI_Source_Select            0x0040 */
/* #define  AI_SI_Source_Select            0x0080 */
/* #define  AI_SI_Source_Select            0x0100 */
/* #define  AI_SI_Source_Select            0x0200 */
/* #define  AI_SI_Source_Select            0x0400 */
/* #define  AI_CONVERT_Source_Select       0x0800 */
/* #define  AI_CONVERT_Source_Select       0x1000 */
/* #define  AI_CONVERT_Source_Select       0x2000 */
/* #define  AI_CONVERT_Source_Select       0x4000 */
/* #define  AI_CONVERT_Source_Select       0x8000 */

unsigned short mirror_AI_Mode_2_Register=0;
/* AI_Mode_2_Register               16         0x0D */
#define AI_SC_Write_Switch             0x0001 
/* #define AI_SC_Reload_Mode              0x0002 */
#define AI_SC_Initial_Load_Source      0x0004 
#define AI_SI_Write_Switch             0x0008 
/* #define AI_SI_Reload_Mode              0x0010 */
/* #define AI_SI_Reload_Mode              0x0020 */
/* #define AI_SI_Reload_Mode              0x0040 */
#define AI_SI_Initial_Load_Source      0x0080 
#define AI_SI2_Reload_Mode             0x0100 
#define AI_SI2_Initial_Load_Source     0x0200 
/* #define Reserved                       0x0400 */
/* #define Reserved                       0x0800 */
#define AI_External_MUX_Present        0x1000 
#define AI_Pre_Trigger                 0x2000 
#define AI_Start_Stop_Gate_Enable      0x4000 
#define AI_SC_Gate_Enable              0x8000 

unsigned short mirror_AI_Mode_3_Register=0;
/* AI_Mode_3_Register               16         0x57 */
/* #define  AI_External_Gate_Select       0x0001 */
/* #define  AI_External_Gate_Select       0x0002 */
/* #define  AI_External_Gate_Select       0x0004 */
/* #define  AI_External_Gate_Select       0x0008 */
/* #define  AI_External_Gate_Select       0x0010 */
#define  AI_External_Gate_Polarity     0x0020
/* #define  AI_FIFO_Mode                  0x0040 */
/* #define  AI_FIFO_Mode                  0x0080 */
#define  AI_External_Gate_Mode         0x0100
#define  AI_Delayed_START1             0x0200
#define  AI_Delayed_START2             0x0400
#define  AI_SI2_Source_Select          0x0800
#define  AI_SI_Special_Trigger_Delay   0x1000
#define  AI_Software_Gate              0x2000
/* #define  Reserved                      0x4000 */
/* #define  Reserved                      0x8000 */

/* AI_Command_1_Register            16         0x08 */
#define AI_CONVERT_Pulse               0x0001
#define AI_SC_TC_Pulse                 0x0002
#define AI_LOCALMUX_CLK_Pulse          0x0004
#define AI_EXTMUX_CLK_Pulse            0x0008
#define AI_SCAN_IN_PROG_Pulse          0x0010
#define AI_SC_Load                     0x0020
#define AI_SC_Arm                      0x0040
#define AI_DIV_Load                    0x0080
#define AI_DIV_Arm                     0x0100
#define AI_SI_Load                     0x0200
#define AI_SI_Arm                      0x0400
#define AI_SI2_Load                    0x0800
#define AI_SI2_Arm                     0x1000
#define AI_Disarm                      0x2000
#define AI_Analog_Trigger_Reset        0x4000
/* #define Reserved                       0x8000 */


/* AI_SC_Save_RegistersH            16         0x42 */
/* #define  AI_SC_Save_Value              0x0001 */
/* #define  AI_SC_Save_Value              0x0002 */
/* #define  AI_SC_Save_Value              0x0004 */
/* #define  AI_SC_Save_Value              0x0008 */
/* #define  AI_SC_Save_Value              0x0010 */
/* #define  AI_SC_Save_Value              0x0020 */
/* #define  AI_SC_Save_Value              0x0040 */
/* #define  AI_SC_Save_Value              0x0080 */
/* #define  Reserved                      0x0100 */
/* #define  Reserved                      0x0200 */
/* #define  Reserved                      0x0400 */
/* #define  Reserved                      0x0800 */
/* #define  Reserved                      0x1000 */
/* #define  Reserved                      0x2000 */
/* #define  Reserved                      0x4000 */
/* #define  Reserved                      0x8000 */

/* AI_SC_Save_RegistersL            16         0x43 */
/* #define  AI_SC_Save_Value              0x0001 */
/* #define  AI_SC_Save_Value              0x0002 */
/* #define  AI_SC_Save_Value              0x0004 */
/* #define  AI_SC_Save_Value              0x0008 */
/* #define  AI_SC_Save_Value              0x0010 */
/* #define  AI_SC_Save_Value              0x0020 */
/* #define  AI_SC_Save_Value              0x0040 */
/* #define  AI_SC_Save_Value              0x0080 */
/* #define  AI_SC_Save_Value              0x0100 */
/* #define  AI_SC_Save_Value              0x0200 */
/* #define  AI_SC_Save_Value              0x0400 */
/* #define  AI_SC_Save_Value              0x0800 */
/* #define  AI_SC_Save_Value              0x1000 */
/* #define  AI_SC_Save_Value              0x2000 */
/* #define  AI_SC_Save_Value              0x4000 */
/* #define  AI_SC_Save_Value              0x8000 */


/* Interrupt_A_Enable_Register      16         0x49 */
#define AI_SC_TC_Interrupt_Enable      0x0001
#define AI_START1_Interrupt_Enable     0x0002
#define AI_START2_Interrupt_Enable     0x0004
#define AI_START_Interrupt_Enable      0x0008
#define AI_STOP_Interrupt_Enable       0x0010
#define AI_Error_Interrupt_Enable      0x0020
#define G0_TC_Interrupt_Enable         0x0040
#define AI_FIFO_Interrupt_Enable       0x0080
#define G0_Gate_Interrupt_Enable       0x0100
#define Pass_Thru_0_Interrupt_Enable   0x0200
/* #define Reserved                       0x0400 */
/* #define Reserved                       0x0800 */
/* #define Reserved                       0x1000 */
/* #define Reserved                       0x2000 */
/* #define Reserved                       0x4000 */
/* #define Reserved                       0x8000 */

/* Interrupt_B_Enable_Register      16         0x4B */
#define AO_BC_TC_Interrupt_Enable      0x0001
#define AO_START1_Interrupt_Enable     0x0002
#define AO_UPDATE_Interrupt_Enable     0x0004
#define AO_START_Interrupt_Enable      0x0008
#define AO_STOP_Interrupt_Enable       0x0010
#define AO_Error_Interrupt_Enable      0x0020
#define AO_UC_TC_Interrupt_Enable      0x0040
#define AO_UI2_TC_Interrupt_Enable     0x0080
#define AO_FIFO_Interrupt_Enable       0x0100
#define G1_TC_Interrupt_Enable         0x0200
#define G1_Gate_Interrupt_Enable       0x0400
#define Pass_Thru_1_Interrupt_Enable   0x0800
/* #define Reserved                       0x1000 */
/* #define Reserved                       0x2000 */
/* #define Reserved                       0x4000 */
/* #define Reserved                       0x8000 */

unsigned short mirror_Interrupt_Control_Register=0;
/* Interrupt_Control_Register       16         0x3B */
#define Interrupt_Output_Polarity      0x0001  
#define Interrupt_Output_On_3_Pins     0x0002  
#define Pass_Thru_1_Interrupt_Polarity 0x0004  
#define Pass_Thru_0_Interrupt_Polarity 0x0008  
/* #define Reserved                       0x0010 */
/* #define Reserved                       0x0020 */
/* #define Reserved                       0x0040 */
/* #define Reserved                       0x0080 */
/* #define Interrupt_A_Output_Select      0x0100 */
/* #define Interrupt_A_Output_Select      0x0200 */
/* #define Interrupt_A_Output_Select      0x0400 */
#define Interrupt_A_Enable             0x0800  
/* #define Interrupt_B_Output_Select      0x1000 */
/* #define Interrupt_B_Output_Select      0x2000 */
/* #define Interrupt_B_Output_Select      0x4000 */
#define Interrupt_B_Enable             0x8000  

char mirror_Serial_Command=0x00;

/* Serial Command Register           8         0x0D */
#define SerClk                          0x0001
#define SerData                         0x0002
#define EEPromCS                        0x0004
#define SerDacLd0                       0x0008
#define SerDacLd1                       0x0010
/* #define Reserved                        0x0020 */
/* #define Reserved                        0x0040 */
/* #define Reserved                        0x0080 */

/* EEPROM adresses for AT-MIO-16E-1, ..16E-2, and ..64-E3 */
#define NI_DAQ_Board_Code		(short) 511
#define Revision         		(short) 510
#define Sub_revision     		(short) 509
#define Year             		(short) 508
#define Month            		(short) 507
#define Day              		(short) 506
#define Factory_Reference_MSB		(short) 426
#define Factory_Reference_LSB		(short) 425
/* value (AI) */
#define CALDAC4          		(short) 424
#define CALDAC1          		(short) 423
#define CALDAC3          		(short) 422
#define CALDAC2          		(short) 421
/* bipolar value (AO) */
/* Unused, I just do AI (analog input).
* #define CALDAC5          		(short) 420
* #define CALDAC7          		(short) 419
* #define CALDAC6          		(short) 418
* #define CALDAC8          		(short) 417
* #define CALDAC10          		(short) 416
* #define CALDAC9          		(short) 415
*/
/* unipolar value (AO) */
/* Unused, I just do AI (analog input).
* #define CALDAC5          		(short) 414
* #define CALDAC7          		(short) 413
* #define CALDAC6          		(short) 412
* #define CALDAC8          		(short) 411
* #define CALDAC10          		(short) 410
* #define CALDAC9          		(short) 409
*/

/* Channel_A_Mode_Register           8         0x03 */
/* #define Channel<2..0>                  0x0001 */
/* #define Channel<2..0>                  0x0002 */
/* #define Channel<2..0>                  0x0004 */
/* #define Transfer<2..0>                 0x0008 */
/* #define Transfer<2..0>                 0x0010 */
/* #define Transfer<2..0>                 0x0020 */
#define TCIntEnable                    0x0040
#define ChanEnable                     0x0080

/* AI_AO_Select_Register             8         0x03 */
#define Input_DMA_A                    0x0001
/* #define Input<C..A>                    0x0001 */
/* #define Input<C..A>                    0x0002 */
/* #define Input<C..A>                    0x0004 */
/* #define Reserved                       0x0008 */
/* #define Output<C..A>                   0x0010 */
/* #define Output<C..A>                   0x0020 */
/* #define Output<C..A>                   0x0040 */
/* #define Reserved                       0x0080 */

/* Joint_Reset_Register             16         0x48 */
#define  AI_Reset                       0x0001
#define  AO_Reset                       0x0002
#define  G0_Reset                       0x0004
#define  G1_Reset                       0x0008
#define  AI_Configuration_Start         0x0010
#define  AO_Configuration_Start         0x0020
#define  AO_UI2_Configuration_Start     0x0040
/* #define  Reserved                       0x0080 */
#define  AI_Configuration_End           0x0100
#define  AO_Configuration_End           0x0200
#define  AO_UI2_Configuration_End       0x0400
#define  Software_Reset                 0x0800
/* #define  Reserved                       0x1000 */
/* #define  Reserved                       0x2000 */
/* #define  Reserved                       0x4000 */
/* #define  Reserved                       0x8000 */

